<?php
/**
  *
  * Copyright (c) 2009, Persistent Systems Limited
  *
  * Redistribution and use, with or without modification, are permitted
  *  provided that the following  conditions are met:
  *   - Redistributions of source code must retain the above copyright notice,
  *     this list of conditions and the following disclaimer.
  *   - Neither the name of Persistent Systems Limited nor the names of its contributors
  *     may be used to endorse or promote products derived from this software
  *     without specific prior written permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
  * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
  * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
  * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
  * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
  * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
  * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
  * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
  * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
  * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  */

//modified for Yii extension odataclient: Don't import the NorthwindEntities.php from the example
//require_once 'NorthwindEntities.php';
//require_once 'urldef.php';


echo "<h3>Sample1: List all cutomer's ID in NorthWind DB with USA as Country using Server Side Paging and print the number of coustmers using inline count</h3>";
try
{
     //$svc = new NorthwindEntities(NORTHWIND_SERVICE_URL);
     $svc = new NorthwindEntities(); //modified for Yii extension odataclient: don't use the internal serviceUri of the example


     $query = $svc->Customers()->filter("Country eq 'USA'")
                               ->IncludeTotalCount();
     $customersResponse = $query->Execute();

     echo "<br/>";
     echo "Number of Customers with Country as USA:" . $customersResponse->TotalCount() . "<br/>";
     echo "CustomerID" . "<br/>";
     echo "----------" . "<br/>";
     $nextCustomerToken = null;

     do
     {
        if($nextCustomerToken != null)
        {
            $customersResponse = $svc->Execute($nextCustomerToken);
        }

        foreach($customersResponse->Result as $customer)
        {
             echo $customer->CustomerID . "<br/>";
        }

     }while(($nextCustomerToken = $customersResponse->GetContinuation()) != null);

}
catch(DataServiceRequestException $ex)
{
        echo 'Error: while running the query ' . $ex->Response->getQuery();
        echo "<br/>";
        echo $ex->Response->getError();
}
catch (ODataServiceException $e)
{
    echo "Error:" . $e->getError() . "<br>" . "Detailed Error:" . $e->getDetailedError();
}
?>
